<div class="container-fluid p-0">
    <div class="title-wrapper flex-fill">
        <h3 id="heading" class="m-0">Reminder Settings</h3>
    </div>
    <div class="breadcrumb-container d-flex align-items-center">
        <span>Reminder</span>
        <mat-icon class="ml-2 mr-2">chevron_right</mat-icon>
        <span>Reminder Settings</span>
    </div>

    <mat-card class="mt-2" [formGroup]="formGroup">
        <mat-card-content>
            <div>
                <h3 class="card-title-wrapper">SMS Subscription</h3>
                <label>Kavanii can automatically send custom appointment reminders to your clients before their
                    appointment. You can also configure other notification settings here.</label>
            </div>

            <div class="d-flex flex-column" style="gap: 45px; margin-top: 45px;">

                <div class="d-flex align-items-center">
                    <kendo-switch [onLabel]="'Disable'" [offLabel]="'Enable'"
                                  formControlName="enableAutoReminder"></kendo-switch>
                    <span class="ml-4">
                        Automatically send Appointment/Event reminders to clients with "Communication Consent".
                    </span>
                </div>

                <div class="d-flex align-items-center">
                    <kendo-switch [onLabel]="'Disable'" [offLabel]="'Enable'"
                                  formControlName="enableWeekendReminder"></kendo-switch>
                    <span class="ml-4">
                        Reminders due to be sent on the weekend will be sent on Friday.
                    </span>
                </div>

                <div class="d-flex align-items-center">
                    <kendo-switch [onLabel]="'Disable'" [offLabel]="'Enable'"
                                  formControlName="enableAutoCancel"></kendo-switch>
                    <span class="ml-4">
                        Automatically cancel the appointment when clients reply 'No' or 'Cancel' to an appointment reminder
                    </span>
                </div>
            </div>

            <div style="border-top: 1px solid #DADADA; margin: 28px -16px;"></div>

            <div class="card-title-wrapper">
                <label class="m-0">Settings</label>
            </div>

            <div style="margin-top: 28px;">

                <kendo-grid #grid class="reminder-settings-grid separator"
                            [data]="gridView"
                            [pageSize]="pageSize" [skip]="skip"
                            [pageable]="true" [columnMenu]="false"
                            (dataStateChange)="dataStateChange($event)" [groupable]="false"
                            [reorderable]="reorder" [sort]="sort"
                            (sortChange)="sortChange($event)" (groupChange)="groupChange($event)"
                            [sortable]="{
                    allowUnsort: allowUnsort,
                    mode: multiple ? 'multiple' : 'single'
                }"
                            [selectable]="{
                                            checkboxOnly: true,
                                            mode: 'multiple'
                                        }" [filterable]="true" [filter]="state.filter"
                            [style.height.%]="100"
                            [kendoGridSelectBy]="'index'"
                            [(selectedKeys)]="selectedRowIds"
                            (drop)="onDrop($event)"
                            (dragover)="onDragOver($event)">

                    <kendo-grid-column [width]="20" [style]="{minWidth: '20px'}">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <mat-icon draggable="true"
                                      (dragstart)="onDragStart($event, dataItem.index)">drag_indicator
                            </mat-icon>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-checkbox-column [showSelectAll]="true" [width]="30">
                    </kendo-grid-checkbox-column>

                    <kendo-grid-column field="reminderName" title="Reminder Name" [width]="150">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <mat-form-field class="rs-mat-field" appearance="outline">
                                <input matInput type="text" [formControl]="getFormControl(dataItem, column.field)"
                                       appCharLimit max="30" [fc]="getFormControl(dataItem, column.field)"/>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="type" title="Type" [width]="100">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <mat-form-field class="rs-mat-field" appearance="outline">
                                <app-dropdown-search
                                        [data]="type"
                                        [formControl]="getFormControl(dataItem, 'reminderType')"
                                        (valueChange)="onTypeChange($event)"></app-dropdown-search>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="template" title="Template" [width]="150">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <mat-form-field class="rs-mat-field" appearance="outline">
                                <app-dropdown-search
                                        [data]="templates"
                                        textField="name"
                                        valueField="id"
                                        [formControl]="getFormControl(dataItem, 'templateId')"
                                (valueChange)="onSelectTemplate($event, dataItem.index)"></app-dropdown-search>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="time" title="Time" [width]="100">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <mat-form-field class="rs-mat-field" appearance="outline">
                                <app-time-picker
                                        [isDisplayIcon]="false"
                                        [interval]="1"
                                        [formControl]="getFormControl(dataItem, 'reminderTime')"
                                ></app-time-picker>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="reminderDays" title="Send(Days)" [width]="100">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <mat-form-field class="rs-mat-field" appearance="outline">
                                <app-dropdown-search
                                        [data]="sendDaysList"
                                        [filterable]="false"
                                        [formControl]="getFormControl(dataItem, 'reminderDays')"></app-dropdown-search>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column title="Action" [width]="80">
                        <ng-template kendoGridCellTemplate let-dataItems>
                            <button (click)="addRow(dataItems.index + 1)"
                                    class="item-setting-btn border-0 bg-transparent cursor-pointer">
                                <mat-icon class="m-0" style="color: #979797;">add</mat-icon>
                            </button>
                            <button (click)="deleteRow(dataItems.index)"
                                    class="ml-2item-setting-btn border-0 bg-transparent cursor-pointer">
                                <mat-icon class="m-0" style="color: #979797;">delete</mat-icon>
                            </button>
                        </ng-template>
                    </kendo-grid-column>
                </kendo-grid>

            </div>

            <div style="margin-top: 84px;">


                <div class="d-flex align-items-center justify-content-end" style="margin-top: 47px;">

                    <button mat-stroked-button style="font-size: 14px;" (click)="cancel()">Cancel</button>
                    <button mat-raised-button class="ml-3" style="font-size: 14px;" [disabled]="formGroup.invalid || !gridData || gridData.length === 0"
                            (click)="save()">Save Settings
                    </button>

                </div>

            </div>
        </mat-card-content>
    </mat-card>
</div>
